VTK: vtkNonMergingPointLocator Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkNonMergingPointLocator Class Reference

direct / check-free point insertion. More...

`#include <vtkNonMergingPointLocator.h>`

Inheritance diagram for vtkNonMergingPointLocator:
[legend]
Collaboration diagram for vtkNonMergingPointLocator:
[legend]

## Public Types
typedef vtkPointLocator | Superclass
Public Types inherited from vtkPointLocator
typedef vtkIncrementalPointLocator | Superclass
| Standard methods for type management and printing. More...
Public Types inherited from vtkIncrementalPointLocator
typedef vtkAbstractPointLocator | Superclass
Public Types inherited from vtkAbstractPointLocator
typedef vtkLocator | Superclass
| Standard type and print methods. More...
Public Types inherited from vtkLocator
typedef vtkObject | Superclass
| Standard type and print methods. More...

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for type management and printing. More...
vtkNonMergingPointLocator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard type and print methods. More...
vtkIdType | IsInsertedPoint (const double[3]) override
| Determine whether a given point x has been inserted into the points list. More...
vtkIdType | IsInsertedPoint (double, double, double) override
| Determine whether or not a given point has been inserted. More...
int | InsertUniquePoint (const double x[3], vtkIdType &ptId) override
| Determine whether a given point x has been inserted into the points list. More...
Public Member Functions inherited from vtkPointLocator
vtkIdType | FindClosestPoint (const double x[3]) override
| Given a position x, return the id of the point closest to it. More...
int | InitPointInsertion (vtkPoints *newPts, const double bounds[6]) override
| Initialize the point insertion process. More...
int | InitPointInsertion (vtkPoints *newPts, const double bounds[6], vtkIdType estNumPts) override
| Initialize the point insertion process. More...
void | InsertPoint (vtkIdType ptId, const double x[3]) override
| Incrementally insert a point into search structure with a particular index value. More...
vtkIdType | InsertNextPoint (const double x[3]) override
| Incrementally insert a point into search structure. More...
int | InsertUniquePoint (const double x[3], vtkIdType &ptId) override
| Determine whether point given by x[3] has been inserted into points list. More...
vtkIdType | FindClosestInsertedPoint (const double x[3]) override
| Given a position x, return the id of the point closest to it. More...
void | FindClosestNPoints (int N, const double x[3], vtkIdList *result) override
| Find the closest N points to a position. More...
void | FindPointsWithinRadius (double R, const double x[3], vtkIdList *result) override
| Find all points within a specified radius R of position x. More...
virtual vtkIdList * | GetPointsInBucket (const double x[3], int ijk[3])
| Given a position x, return the list of points in the bucket that contains the point. More...
virtual vtkIdType | FindClosestPoint (const double x[3])=0
| Given a position x, return the id of the point closest to it. More...
vtkIdType | FindClosestPoint (double x, double y, double z)
virtual void | SetDivisions (int, int, int)
| Set the number of divisions in x-y-z directions. More...
virtual void | SetDivisions (int[3])
| Set the number of divisions in x-y-z directions. More...
virtual int * | GetDivisions ()
| Set the number of divisions in x-y-z directions. More...
virtual void | GetDivisions (int data[3])
| Set the number of divisions in x-y-z directions. More...
virtual void | SetNumberOfPointsPerBucket (int)
| Specify the average number of points in each bucket. More...
virtual int | GetNumberOfPointsPerBucket ()
| Specify the average number of points in each bucket. More...
vtkIdType | FindClosestPointWithinRadius (double radius, const double x[3], double &dist2) override
| Given a position x and a radius r, return the id of the point closest to the point in that radius. More...
virtual vtkIdType | FindClosestPointWithinRadius (double radius, const double x[3], double inputDataLength, double &dist2)
| Given a position x and a radius r, return the id of the point closest to the point in that radius. More...
vtkIdType | IsInsertedPoint (double x, double y, double z) override
| Determine whether point given by x[3] has been inserted into points list. More...
vtkIdType | IsInsertedPoint (const double x[3]) override
| Determine whether point given by x[3] has been inserted into points list. More...
virtual void | FindDistributedPoints (int N, const double x[3], vtkIdList *result, int M)
| Find the closest points to a position such that each octant of space around the position contains at least N points. More...
virtual void | FindDistributedPoints (int N, double x, double y, double z, vtkIdList *result, int M)
| Find the closest points to a position such that each octant of space around the position contains at least N points. More...
virtual vtkPoints * | GetPoints ()
| Provide an accessor to the points. More...
void | Initialize () override
| See vtkLocator interface documentation. More...
void | FreeSearchStructure () override
| See vtkLocator interface documentation. More...
void | BuildLocator () override
| See vtkLocator interface documentation. More...
void | ForceBuildLocator () override
| See vtkLocator interface documentation. More...
void | GenerateRepresentation (int level, vtkPolyData *pd) override
| See vtkLocator interface documentation. More...
vtkPointLocator * | NewInstance () const
| Standard methods for type management and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type management and printing. More...
Public Member Functions inherited from vtkIncrementalPointLocator
vtkIncrementalPointLocator * | NewInstance () const
Public Member Functions inherited from vtkAbstractPointLocator
vtkIdType | FindClosestPoint (double x, double y, double z)
| Given a position x, return the id of the point closest to it. More...
void | FindClosestNPoints (int N, double x, double y, double z, vtkIdList *result)
| Find the closest N points to a position. More...
void | FindPointsWithinRadius (double R, double x, double y, double z, vtkIdList *result)
| Find all points within a specified radius R of position x. More...
virtual double * | GetBounds ()
| Provide an accessor to the bounds. More...
virtual void | GetBounds (double *)
| Provide an accessor to the bounds. More...
virtual vtkIdType | GetNumberOfBuckets ()
| Return the total number of buckets in the locator. More...
vtkAbstractPointLocator * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkLocator
virtual void | Update ()
| Cause the locator to rebuild itself if it or its input dataset has changed. More...
virtual void | SetDataSet (vtkDataSet *)
| Build the locator from the points/cells defining this dataset. More...
virtual vtkDataSet * | GetDataSet ()
| Build the locator from the points/cells defining this dataset. More...
virtual void | SetMaxLevel (int)
| Set the maximum allowable level for the tree. More...
virtual int | GetMaxLevel ()
| Set the maximum allowable level for the tree. More...
virtual int | GetLevel ()
| Get the level of the locator (determined automatically if Automatic is true). More...
virtual void | SetAutomatic (vtkTypeBool)
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual vtkTypeBool | GetAutomatic ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOn ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | AutomaticOff ()
| Boolean controls whether locator depth/resolution of locator is computed automatically from average number of entities in bucket. More...
virtual void | SetTolerance (double)
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual double | GetTolerance ()
| Specify absolute tolerance (in world coordinates) for performing geometric operations. More...
virtual void | SetUseExistingSearchStructure (vtkTypeBool)
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkTypeBool | GetUseExistingSearchStructure ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOn ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual void | UseExistingSearchStructureOff ()
| Get/Set UseExistingSearchStructure, which when enabled it allows the locator to NOT be built again. More...
virtual vtkMTimeType | GetBuildTime ()
| Return the time of the last data structure build. More...
bool | UsesGarbageCollector () const override
| Handle the PointSet <-> Locator loop. More...
vtkLocator * | NewInstance () const
| Standard type and print methods. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Static Public Member Functions
static vtkNonMergingPointLocator * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkNonMergingPointLocator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkPointLocator
static vtkPointLocator * | New ()
| Construct with automatic computation of divisions, averaging 25 points per bucket. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type management and printing. More...
static vtkPointLocator * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type management and printing. More...
Static Public Member Functions inherited from vtkIncrementalPointLocator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkIncrementalPointLocator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractPointLocator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkAbstractPointLocator * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkLocator
static vtkTypeBool | IsTypeOf (const char *type)
| Standard type and print methods. More...
static vtkLocator * | SafeDownCast (vtkObjectBase *o)
| Standard type and print methods. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for type management and printing. More...
| vtkNonMergingPointLocator ()=default
| ~vtkNonMergingPointLocator () override=default
Protected Member Functions inherited from vtkPointLocator
| vtkPointLocator ()
| ~vtkPointLocator () override
void | BuildLocatorInternal () override
| This function is not pure virtual to maintain backwards compatibility. More...
void | GetBucketNeighbors (vtkNeighborPoints *buckets, const int ijk[3], const int ndivs[3], int level)
void | GetOverlappingBuckets (vtkNeighborPoints *buckets, const double x[3], const int ijk[3], double dist, int level)
void | GetOverlappingBuckets (vtkNeighborPoints *buckets, const double x[3], double dist, int prevMinLevel[3], int prevMaxLevel[3])
void | GenerateFace (int face, int i, int j, int k, vtkPoints *pts, vtkCellArray *polys)
double | Distance2ToBucket (const double x[3], const int nei[3])
double | Distance2ToBounds (const double x[3], const double bounds[6])
void | GetBucketIndices (const double *x, int ijk[3]) const
vtkIdType | GetBucketIndex (const double *x) const
void | ComputePerformanceFactors ()
Protected Member Functions inherited from vtkIncrementalPointLocator
| vtkIncrementalPointLocator ()
| ~vtkIncrementalPointLocator () override
Protected Member Functions inherited from vtkAbstractPointLocator
| vtkAbstractPointLocator ()
| ~vtkAbstractPointLocator () override
Protected Member Functions inherited from vtkLocator
| vtkLocator ()
| ~vtkLocator () override
void | ReportReferences (vtkGarbageCollector *) override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkPointLocator
vtkPoints * | Points
int | Divisions [3]
int | NumberOfPointsPerBucket
vtkIdList ** | HashTable
double | H [3]
double | InsertionTol2
vtkIdType | InsertionPointId
double | InsertionLevel
double | HX
double | HY
double | HZ
double | FX
double | FY
double | FZ
double | BX
double | BY
double | BZ
vtkIdType | XD
vtkIdType | YD
vtkIdType | ZD
vtkIdType | SliceSize
Protected Attributes inherited from vtkAbstractPointLocator
double | Bounds [6]
vtkIdType | NumberOfBuckets
Protected Attributes inherited from vtkLocator
vtkDataSet * | DataSet
vtkTypeBool | UseExistingSearchStructure
vtkTypeBool | Automatic
double | Tolerance
int | MaxLevel
int | Level
vtkTimeStamp | BuildTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

direct / check-free point insertion.

As a special sub-class of vtkPointLocator, vtkNonMergingPointLocator is intended for direct / check-free insertion of points into a vtkPoints object. In other words, any given point is always directly inserted. The name emphasizes the difference between this class and its sibling class vtkMergePoints in that the latter class performs check-based zero tolerance point insertion (or to 'merge' exactly duplicate / coincident points) by exploiting the uniform bin mechanism employed by the parent class vtkPointLocator. vtkPointLocator allows for generic (zero and non- zero) tolerance point insertion as well as point location.

See also
  vtkIncrementalPointLocator vtkPointLocator vtkMergePoints

Definition at line 31 of file vtkNonMergingPointLocator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkPointLocator vtkNonMergingPointLocator::Superclass

Definition at line 36 of file vtkNonMergingPointLocator.h.

## Constructor & Destructor Documentation

## ◆ vtkNonMergingPointLocator()

vtkNonMergingPointLocator::vtkNonMergingPointLocator | ( |  | ) |
| protecteddefault

## ◆ ~vtkNonMergingPointLocator()

vtkNonMergingPointLocator::~vtkNonMergingPointLocator | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkNonMergingPointLocator* vtkNonMergingPointLocator::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkNonMergingPointLocator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkNonMergingPointLocator::IsA | ( | const char * | type | ) |
| virtual

Standard methods for type management and printing.

Reimplemented from vtkPointLocator.

## ◆ SafeDownCast()

static vtkNonMergingPointLocator* vtkNonMergingPointLocator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkNonMergingPointLocator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for type management and printing.

Reimplemented from vtkPointLocator.

## ◆ NewInstance()

vtkNonMergingPointLocator* vtkNonMergingPointLocator::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkNonMergingPointLocator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard type and print methods.

Reimplemented from vtkIncrementalPointLocator.

## ◆ IsInsertedPoint() [1/2]

vtkIdType vtkNonMergingPointLocator::IsInsertedPoint | ( | const double | [3] | ) |
| inlineoverridevirtual

Determine whether a given point x has been inserted into the points list.

Return the id of the already inserted point if it is true, or -1 else. Note this function always returns -1 since any point is always inserted.

Implements vtkIncrementalPointLocator.

Definition at line 44 of file vtkNonMergingPointLocator.h.

## ◆ IsInsertedPoint() [2/2]

vtkIdType vtkNonMergingPointLocator::IsInsertedPoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inlineoverridevirtual

Determine whether or not a given point has been inserted.

Return the id of the already inserted point if true, else return -1. InitPointInsertion() should have been called in advance.

Implements vtkIncrementalPointLocator.

Definition at line 45 of file vtkNonMergingPointLocator.h.

## ◆ InsertUniquePoint()

int vtkNonMergingPointLocator::InsertUniquePoint | ( | const double | x[3],
|  | vtkIdType & | ptId
| ) |  |
| overridevirtual

Determine whether a given point x has been inserted into the points list.

Return 0 if a duplicate has been inserted in the list, or 1 else. Note this function always returns 1 since any point is always inserted. The index of the point is returned via ptId.

Implements vtkIncrementalPointLocator.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkNonMergingPointLocator.h